@import "variables.scss";
@import "root.scss";

:root {
    color-scheme: light dark;
}

a {text-decoration:none}

a:link {
  color: $link-color;
  @include dark {
    color: $dark-link-color;
  }
  &:hover {text-decoration: underline}
}
a:visited {
  color: $visited-link-color;
  @include dark {
    color: $dark-visited-link-color;
  }
  &:hover {text-decoration: underline}
}

pre, code {
    font-family: sfmono-regular,consolas,liberation mono,menlo,monospace, monospace;
    padding: 3px 5px 2px;
    border-radius: 3px;

    background: lighten($neutral-shade, 28%);
    @media (prefers-contrast: more) {
      background: #f8f8f8;
      color: black;
    }
}
pre.one-liner {
    width: fit-content; min-width: 33%;
}

code {
    font-size: 0.9em;
    white-space: pre-wrap;
    @include dark {
      background: lighten($dark-neutral-shade, 3%);
      color: lighten($dark-text-color, 17%);
    }
}
a code {
    padding: 3px 3px 2px;
    @include dark {
      text-shadow: 1px 1px 0 black;
    }
}
a:link code {
    background: var(--link-code-background-color);
}
a:visited code {
    background: lighten($visited-link-color, 65%);
    @include dark {
      background: rgba(lighten($visited-link-color, 10%), 0.5);
    }
}
a:link:not(:hover) code {
    border-bottom: 1px solid lighten($neutral-shade, 20%);
    @include dark {
      border-bottom: 1px solid lighten($dark-neutral-shade, 20%);
    }
    padding-bottom: 1px;
}
a:visited:not(:hover) code {
    border-bottom: 1px solid lighten($visited-link-color, 50%);
    @include dark {
      border-bottom: 1px solid lighten($dark-visited-link-color, 50%);
    }
    padding-bottom: 1px;
}

pre {
    padding: 0.5em 2ex;
    line-height: 1.45;
    font-size: 0.9em;
    white-space: pre-wrap;
    overflow: auto;
    @include dark {
      background: $dark-neutral-shade;
      color: lighten($dark-text-color, 25%);
    }
}
pre[lang=toml] {
  width: fit-content;
  min-width: 50%;
}
pre code {
    border-radius: 0;
    padding: 0;
    background: transparent;
    font-size: inherit;
}

h1,h2,h3,h4,h5 {
  a > code {
    font-weight: normal;
  }
  code {
    font-size: 1.1em;
    font-family: 'fira code', 'interstate mono', consolas, monospace, monospace;
    background-color: #fcfcfb;
    @include dark {
      background-color: rgba(#fcfcfb, 0.15);
    }
  }
}

table {
    border-collapse: collapse;
    img {
        vertical-align: bottom;
    }
}

.readme {
    overflow: auto;
    img {
        font-size: 10px;
        line-height: 15px;
        font-weight: 300;
        object-fit: contain;
        max-width: 100%;
        &[align="left"] {
          margin: 0 1em 0.7em 0;
        }
        &[align="right"] {
          margin: 0 0 0.7em 1em;
        }
        @media (max-width: 1000px) { // 200px sidebar
          &[width="800"] {
            height: auto; // when shrinks, reclaim height on mobile
          }
        }
    }
    table {
      margin-top: 0.25em;
      margin-bottom: 1em;
    }
    table, td, th {
        border: 1px solid #dddfe4;
        @include dark {
          border-color: #666;
        }
    }
    td, th {
      padding: 4px 8px;
    }
    tr:nth-child(even) {
      td, th {
        background: #fbfcfd;
        @include dark {
          background: rgba(0,0,0,0.25);
        }
      }
    }
    thead > tr {
      > td, > th {
        background: #f9fafb;
        border-color: #eee;
        border-bottom-color: #ccc;
        @include dark {
          background: rgba(255,255,255,0.1);
          border-color: #888;
        }
      }
    }
}

#search_q {
  scroll-margin-block: 160px;
}
aside.search-link {
  float: right;
  svg {
    width: 1em; height: 1em;
    @include dark {
      * {
        stroke: $dark-text-color;
      }
      &:hover * {
        stroke: white;
      }
    }
  }
}

header {
    padding-top: 1em;
    background: $header-color;
    @include dark {
      background: $dark-header-color;
    }
    a {
        // just easier to click
        padding: 0.4em 0;
        :visited {
          color: $visited-link-color;
          @include dark {
            color: $dark-visited-link-color;
          }
        }
    }
    .breadcrumbs {
        cursor: default;
        font-size: 1em;
        line-height: 1.33;
        display: inline;
        > h1 {
            font: inherit;
            font-weight: bold;
            margin: 0;
            display: inline;
        }

        .categories a {
            white-space: nowrap;
        }
        .has-keywords {
            margin-right: 1.5em;
        }
        .parent-crate {
          font-weight: bold;
        }
    }
    .keywords {
      cursor: default;
      > span { // first 3
          white-space: nowrap;
      }
    }

    .keyword {
        padding-right: 1.15ex;
        &:not([href]) {
          opacity: var(--gamma-opacity6);
          cursor: default;
        }
    }
    .keyword > span {
        opacity: var(--gamma-opacity6);
        padding-right: 0.1ex;
        text-decoration: none;
    }
    .gh-logo {color:inherit;} /* in link, needs to adapt to dark theme */
    h2 {

      @include dark {
          color: lighten($dark-text-color, 5%);
      }
        .un {
          font-weight: 150;
          opacity: 0.75;
        }

        overflow-wrap: break-word;
        word-wrap: break-word;

        hyphens: auto;

        font-size: 3.5em;
        @media (max-width: 640px) {
            font-size: 3em;
        }
        @media (max-width: 480px) {
            font-size: 2.5em;
        }
        line-height: 1.08;
        margin: 0.44em 0 0;
        .labels {
            user-select: none;
            cursor: default;
            display: block;
            font-size: 0.4em;
            line-height: 1;
            margin: 0 0 0.45em 0;
            font-weight: normal;
            > span {
                border: 2px solid;
                border-radius: 5px;
                padding: 0 0.4ex;
                color: #777;
                &.yanked {
                    color: var(--red-shade);
                }
                &.nightly {
                  background: $blue-shade;
                  color: #f8f8f8;
                  border-color: #fff;
                }
            }
        }
    }
    .desc {
        margin:0.4em 0;
        font-weight: 300;
        @media (prefers-contrast: more) {
          font-weight: normal;
        }
        code {
            background: transparent;
            padding: 0;
        }
        max-height: 18em;
        overflow-y: auto;
    }
    .desc + p {
        margin: 0;
        line-height: 1.33;
        @media (max-width: 640px) {
            font-size: 0.95em;
        }
    }
    .byline {
        cursor: default;
        a, .contributors, .coowners > span {
            white-space: nowrap;
        }
        a.contributor:not(:hover):not(:focus) {
            color: inherit;
        }
    }
    h2 + .byline {
      margin-top: 0.7em; // that's for crates without description
    }

    nav {
        user-select: none;
        margin: 2em 0 0;
        > ul {
            font-size: 0.85em;
            @media (max-width: 640px) {
                font-size: 0.75em;
            }
            display: flex;
            flex-shrink: 1;
            flex-wrap: wrap-reverse;
            white-space: nowrap;
            list-style: none;
            margin: 0; padding: 0;
            > li {
                cursor: default;
                &.active {
                    background: var(--background-color);
                    color: var(--text-color);
                    @include dark {
                      border-bottom-color: $dark-inverted-text-color;
                      background: $dark-background-color;
                      color: $dark-text-color;
                    }
                    @media (max-width: 480px) {
                        display: none;
                    }
                }
                margin: 0 0.5em 0 0;
                padding: 0 0 2px;
                > a, > span {
                  display: block;
                }
                > a {
                  &.button {
                    border-radius: 3px;
                    margin-right: 1em;
                    background-color: lighten($header-color, 3%);
                    &:hover {
                      background: mix($background-color, $header-color, 75%);
                    }
                    @include dark {
                      background-color: lighten($dark-header-color, 6%);
                      &:hover {
                        background-color: lighten($dark-header-color, 12%);
                      }
                    }
                  }
                  &:hover {
                    text-decoration: none;
                    &:link {
                      color: var(--link-color)
                    }
                    &:visited {
                      color: var(--visited-link-color)
                    }
                  }
                }
                > a, > span, &.active {
                  padding: 0.42em 1.9em 0.4em;
                  @media (max-width: 640px) {
                      padding-right: 1em;
                      padding-left: 1em;
                  }
                }
                &:first-child:not(.active) {
                  > a:not(.button) {
                    padding-left: 0.7ex; // has no border, looks stupid indented
                  }
                }
                &.sort-by:not(:hover):not(:focus-within) {
                  opacity: var(--gamma-opacity6);
                }
                &.sort-by {
                  margin-left: auto;
                  padding-right: 0;
                  a, b {
                    font-weight: normal;
                    padding: 0 0.5ex;
                  }
                  @media (max-width: 640px) {
                    b { display: none; }
                  }
                }
            }
        }
    }
    &.nightly, &.yanked {
      color: var(--inverted-text-color);
      @include dark {
        background: darken($blue-shade, 20%);
      }
      .keyword > span {
        opacity: 0.9;
      }
      h2 .labels > span {
        color: lighten($neutral-shade, 5%);
        &.yanked {
          color: lighten($red-shade, 10%);
        }
        &.nightly {
          color: var(--blue-shade);
          border-color:lighten($neutral-shade, 20%);
          background: lighten($neutral-shade, 20%);
        }
      }
    }
    &.nightly {
      accent-color: darken($blue-shade, 10%);
      background: darken($blue-shade, 10%);
      a:not(.button):link {
        color: lighten($link-color, 50%);
        @include dark {
          color: lighten($dark-link-color, 0%);
        }
      }
      a:not(.button):visited {
        color: lighten($visited-link-color, 30%);
        @include dark {
          color: lighten($dark-visited-link-color, 0%);
        }
      }
    }
    &.yanked {
      accent-color: darken($red-shade, 10%);
      background: darken($red-shade, 10%);
      a:link {
        color: lighten($neutral-shade, 20%);
      }
      a:visited {
        color: mix($red-shade, lighten($neutral-shade, 20%));
      }
    }
}

.obsolete-crate {
  accent-color: #777;
  color: var(--text-color-fade);
  opacity: 0.9;
}

#readme-deps {
  display: flex;
  > div {
    min-width: 75%;

  }
}

#versions {
  color: var(--text-color); // override .obsolete

    .edition-2018 {
      font-size: 0.7em;
      margin-top: 0;
    }
    del {
      color: var(--neutral-shade);
      text-decoration-color: darken($neutral-shade, 100%);
      font-weight:200;
      @include dark {
        color: darken($dark-text-color, 30%);
        text-decoration-color: lighten($dark-neutral-shade, 50%);
      }
    }
    h3 {font-size: 1em; margin: 1em 0 0.5em;}
    .date {
        text-align:justify;
        text-align:justify-all;
        text-align-last:justify;
        white-space: nowrap;
    }
    h3 {
      margin-bottom: 0;
    }
    h3 > span {
      font-weight: normal;
    }
    .new {
      cursor: default;
      border: 1px solid lighten($orange-shade, 35%);
      color: var(--orange-shade);
      @include dark {
        background: lighten($dark-neutral-shade, 20%);
        border: 1px solid lighten($dark-neutral-shade, 30%);
      }
      @include little-pill;
      @include little-pill-padding-border;
      vertical-align: 20%;
    }

    table, td, th {
        border: 0;
    }
    th {
        padding-right: 0.8ex;
        text-align: right;
        font-feature-settings: "tnum";
        font-variant-numeric: tabular-nums;
        span {
          font-weight: 300;
        }
    }
}

.about-crate {
  @include dark {
    b, strong, th {
      font-weight: 500;
      color: $dark-text-color-highlight;
    }
  }
  margin: 0 0 2em;
    &::after {
      content:""; // space after downloads
      width: 0px;
    }
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
    flex-grow: 1;
    > * {
        &:last-child {
            flex-grow: 0;
            flex-shrink: 1;
        }
        margin: 0 0 0 1em;
        padding: 0 0 0 1em;
        &:first-child {
            margin-left: 0;
            padding-left: 0;
            border-left: 0;
        }
    }
    #license {
        margin: 1em 0 0.5em;
    }
}


#downloads {
    svg {display:block; margin: 0.8em 0 0.5em}
    @include dark {
      svg {background: lighten($dark-header-color, 3%);}
    }
    p {margin: 0;}
    p:first-child {margin: 1em 0 0.5em;}
}

#sloc {
  flex-basis: 8em;
  p {
    margin: 0.5em 0;
  }
}

.sus-files {
  max-height: 14em; overflow-y: auto;
  span {
    word-break: break-word;
    font-size: 0.9em;
  }
}

#deps {
    cursor: default;
    padding: 1em 0.5em 1em 1.5em;
    min-width: 10em;
    margin-bottom: 1em;
    max-width: 35%;

    h4 {
      margin: 0 0 0.25em;
      font-weight: normal;
    }
    > p {
      margin: 0.5em 0;
    }

    li {margin: 0; padding: 0}
    ul {
        margin: 0 0 0.5em 1.2em; padding: 0;
    }
    ul.dev, li.optional {
        list-style-type: circle;
    }
    ul.features {
      &.long > li {
        display: inline-block;
      }
      list-style-type: none;
    }

    ul.long, ul.long + ul {
        line-height: 1.3;
    }
    .version {
      &.obsolete, &.deprecated {
        color: var(--red-shade);
        font-weight: bold;
      }
      &.outdated {
        color: var(--orange-shade);
      }
      &.top {
        display: none;
      }
    }
    code {
      background: transparent;
      padding: 0;
    }
}

#deps {
    overflow: hidden;

}

// font size must not apply to nested .cfgs
#deps li > .cfg, #deps-features dt > .cfg {
  @include little-pill-once;
  vertical-align: 17%;
}

#deps, #deps-features {
    .version, .with-feature {
        font-size: 0.8em;
    }
    .label, .with-feature:not(:hover) {
        color: lighten($text-color, 50%);
    }
    .feature {
      background: lighten($neutral-shade, 31%);
      border: 1px dotted lighten($neutral-shade, 0%);
      color: darken($brown-shade, 20%);
      @media (prefers-contrast: more) {
        color: black;
      }

      @include dark {
        background: lighten($dark-neutral-shade, 10%);
        color: lighten($brown-shade, 15%);
        border: 1px dotted lighten($dark-neutral-shade, 50%);
      }
      @include little-pill-padding-border;
    }
    .label, .feature {
      @include little-pill;
      vertical-align: 17%;
    }
    a.feature:hover, a.feature:active {
      border-style: solid;
    }
    .label  {
      @include little-pill-padding;
      color: var(--inverted-text-color);
      background: $blue-shade;
      &.label-dev {
        color: var(--inverted-text-color);
        background: lighten($brown-shade, 20%);
        @include dark {
          background: lighten($brown-shade, 0%);
        }
      }
      &.label-build {
        color: darken($brown-shade, 0%);
        background: var(--background-color);
        border: 1px solid lighten($brown-shade, 40%);
        @include dark {
          color: darken($brown-shade, 10%);
          border: 1px solid lighten($brown-shade, 40%);
          background: lighten($dark-neutral-shade, 75%);
        }
        @include little-pill-padding-border;
      }
    }
    .label- {display:none;}
    .with-feature {
        line-height: 1;
    }

    .cfg {
      background: lighten($neutral-shade, 10%);
      color: var(--inverted-text-color);
      @include dark {
        background: lighten($dark-neutral-shade, 20%);
        color: $dark-inverted-text-color;
      }
    }
    .cfg, .k {
      @include little-pill-idempotent;
    }
    .k {
      @include little-pill-padding;
    }
    .all > .k:not(:first-child) {
      padding-left: 0;
    }
    .any {
      background: none;
      padding: 0;
    }
    .all > .any {
      background: var(--background-color);
      border: 1px solid lighten($neutral-shade, 10%);
      @include dark {
        background: $dark-background-color;
        border: 1px solid lighten($dark-neutral-shade, 10%);
      }
      padding: 1px;
      .k {
        padding: 0 3px;
      }
    }
    .not {
      white-space: nowrap;
      padding: 0 0 0 3px;
      > .k, > .any > .k  {
        background: lighten($red-shade, 10%);
        color: lighten($inverted-text-color, 10%);
        border: 1px solid lighten($red-shade, 10%);
        @include dark {
          background: darken($red-shade, 10%);
          color: lighten($dark-text-color, 10%);
          border: 1px solid darken($red-shade, 5%);
        }
        text-shadow: none;
        padding-top: 0;
        padding-bottom: 1px;
      }
      > .any {
        margin-right: 3px;
      }
      > .any > .all {
        white-space: nowrap;
        border-left: 1px solid var(--background-color);
        border-right: 1px solid var(--background-color);
      }
    }
    .other-features a { text-decoration: underline; }
}

@media (max-width: 740px) {
  #readme-deps {
    display: block;
    #deps {
      > h4 {
        font-weight: bold;
        > a:not(:hover) {
           color: inherit;
        }
      }
      padding: 1em 0 0;
      max-width: none;
      > div {
        columns: auto;
        column-width: 10em;
      }
    }
  }
}


// #badges {
//     .badge {
//         border-radius: 3px;
//         background: lighten($neutral-shade, 50%);
//         color: var(--background-color);
//         font-family: DejaVu Sans,Verdana,Geneva,sans-serif;
//         font-size: 11px;
//         line-height: 20px;
//         display: inline-block;
//         margin: 0;
//         vertical-align: top;
//         padding: 0 6px;
//         border-right: 7px solid var(--green-shade);
//     }
//     padding-top: 7px;
//     > a {
//         padding: 10px;
//         padding-left: 0;
//     }
// }

main {
    min-height: 52vh
}


hr {
    border: 0;
    border-top: 1px dotted darken($neutral-shade, 20%);
    @include dark {
      border-top: 2px dashed black;
    }
    margin: 1.4em 0;
    height: 0;
}

body > footer {
    cursor: default;
    color: var(--inverted-text-color);
    background: darken($neutral-shade, 50%);
    @include dark {
      color: $dark-text-color;
      background: #000;
    }
    margin: 2em 0 0;
    font-weight: 300;
    padding: 1em;
    a:link {
        color: $dark-link-color;
        @include dark {
          color: lighten($link-color, 33%);
        }
    }
    a:visited {
        color: lighten($dark-visited-link-color, 15%);
        @include dark {
          color: lighten($visited-link-color, 45%);
        }
    }

    p {
        font-size: 0.9em;
    }
}

p.empty {
    padding-left: 0.5em;
    font-size: 1.5em;
    color: #777;
    @include dark {
        color: #aab;
    }
}

details.reveal[open] {
  summary {
    display: none;
  }
}
details.reveal:not([open]) {
  margin: 2em 0;
  display: block;
  summary {
    cursor: pointer;
    color: var(--link-color);
  }
}

small {
  font-size: 0.83em;
}

:target {
  scroll-margin-block: 5ex;
}

h1, h2 {
  text-decoration-skip-ink: auto;
  text-wrap: balance;
}

@import "fira.scss";
@import "syntax_theme.scss";
@import "category.scss";
